%define name	bind8
%define version	8.4.6
%define release	1mdk

Summary:	A DNS (Domain Name System) server
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	distributable
Group:		System/Servers
URL:		http://www.isc.org/bind.html
Source0:	ftp://ftp.isc.org/isc/bind/src/%{version}/bind-src.tar.gz
Source1:	ftp://ftp.isc.org/isc/bind/src/%{version}/bind-src.tar.gz.asc
Source2:	bind-8.4.5-manpages.tar.bz2
Source3:	0.0.127.in-addr.arpa.db.bz2
Source4:	localhost.db.bz2
Source5:	named8.conf.bz2
Source6:	named8.init.bz2
Source7:	named8.sysconfig.bz2
Source8:	named8.logrotate.bz2
Source9:	bind8-chroot.sh.bz2
Source10:	named8.root.bz2
Patch0:		bind-8.2.2-rh.patch.bz2
Patch1:		bind-8.1.2-nonlist.patch.bz2
Patch2:		bind-8.4.0-fds.patch.bz2
Patch3:		bind-8.2-host.patch.bz2
Patch4:		bind8-8.4.5-bind8_tagging.diff.bz2
PreReq:		rpm-helper
BuildRequires:	flex
BuildRequires:	glibc-static-devel
Buildroot:	%{_tmppath}/%{name}-%{version}-root

%description
BIND (Berkeley Internet Name Domain) is an implementation of the DNS
(Domain Name System) protocols. BIND includes a DNS server (named), 
which resolves host names to IP addresses, and a resolver library 
(routines for applications to use when interfacing with DNS).  A DNS 
server allows clients to name resources or objects and share the 
information with other network machines.  The named DNS server can be 
used on workstations as a caching name server, but is generally only 
needed on one machine for an entire network.  Note that the 
configuration files for making BIND act as a simple caching nameserver 
are included in the caching-nameserver package.  

Install the bind package if you need a DNS server for your network.  If
you want bind to act a caching name server, you will also need to install
the caching-nameserver package.

%package	utils
Summary:	DNS utilities:  host, dig, dnsquery, and nslookup
Group:		Networking/Other
Requires:	bind8 = %{version}-%{release}

%description	utils
bind8-utils contains a collection of utilities for querying DNS (Domain
Name Service) name servers to find out information about Internet hosts.
These tools will provide you with the IP addresses for given host names,
as well as other information about registered domains and network 
addresses.

You should install bind8-utils if you need to get information from
DNS name servers.

%prep

%setup -q -c -a2
%patch0 -p1
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1

bzcat %{SOURCE3} > 0.0.127.in-addr.arpa.db
bzcat %{SOURCE4} > localhost.db
bzcat %{SOURCE5} > named8.conf
bzcat %{SOURCE6} > named8.init
bzcat %{SOURCE7} > named8.sysconfig
bzcat %{SOURCE8} > named8.logrotate
bzcat %{SOURCE9} > bind8-chroot.sh
bzcat %{SOURCE10} > named8.root

# clean up cvs junk
for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -r $i; fi >&/dev/null
done

find . -name Makefile | xargs perl -pi -e "s/^INSTALL_LIB.*//g" # Fix build as user

rm -f compat/include/sys/cdefs.h

%build
# Oden Erikssons ugly, but dynamic hack instead of a static patch file...
cat > src/port/linux/Makefile.set << EOF
'CC=gcc -fPIC -D_GNU_SOURCE -DIP_RECVDSTADDR'
'CDEBUG=${RPM_OPT_FLAGS} -fPIC'
'DESTBIN=%{_bindir}'
'DESTSBIN=%{_sbindir}'
'DESTEXEC=%{_sbindir}'
'DESTMAN=%{_mandir}'
'DESTHELP=%{_libdir}'
'DESTETC=%{_sysconfdir}'
'DESTLIB=%{_libdir}'
'DESTINC=%{_includedir}'
'DESTRUN=/var/run/named8'
'EXE=8'
'LEX=flex -8 -I'
'YACC=yacc -d'
'SYSLIBS='
'LIBL=-lfl'
'INSTALL=install'
'MANDIR=man'
'MANROFF=cat'
'CATEXT=\$\$N'
'PS=ps p'
'AR=ar crus'
'RANLIB=:'
EOF

# force this to work
perl -pi -e "s|^DEFS.*|DEFS = -D_PATH_HELPFILE=\\\\\"%{_libdir}/nslookup8.help\\\\\"|g" src/bin/nslookup/Makefile

%make -C src
make clean all -C src SUBDIRS=../doc/man

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

# make some directories
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_mandir}/man{1,3,5,7,8}
install -d %{buildroot}/var/run/named8
install -d %{buildroot}/var/log/named8
install -d %{buildroot}/var/named8

make \
    DESTDIR=%{buildroot} \
    install -C src

make \
    DESTDIR=%{buildroot} \
    INSTALL="install" \
    STRIP="" \
    install -C src \
    SUBDIRS=../doc/man 

install -m0755 named8.init %{buildroot}%{_initrddir}/named8
install -m0644 named8.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/named8
install -m0644 named8.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/named8
install -m0755 bind8-chroot.sh %{buildroot}%{_sbindir}/bind8-chroot.sh

echo "; Use \"dig8 @A.ROOT-SERVERS.NET . ns\" to update this file if it's outdated." > named.cache
cat named8.root >> named.cache

install -m0644 named8.conf %{buildroot}%{_sysconfdir}/
install -m0644 named.cache %{buildroot}/var/named8/
install -m0644 0.0.127.in-addr.arpa.db %{buildroot}/var/named8/
install -m0644 localhost.db %{buildroot}/var/named8/

# rename these here
mv %{buildroot}%{_mandir}/man1/dnskeygen.1 \
    %{buildroot}%{_mandir}/man1/dnskeygen8.1
mv %{buildroot}%{_mandir}/man5/named.conf.5 \
    %{buildroot}%{_mandir}/man5/named8.conf.5
mv %{buildroot}%{_mandir}/man8/named.8 \
    %{buildroot}%{_mandir}/man8/named8.8
mv %{buildroot}%{_mandir}/man8/ndc.8 \
    %{buildroot}%{_mandir}/man8/ndc8.8
mv %{buildroot}%{_mandir}/man8/named-xfer.8 \
    %{buildroot}%{_mandir}/man8/named-xfer8.8
#
mv %{buildroot}%{_mandir}/man1/dig.1 \
    %{buildroot}%{_mandir}/man1/dig8.1
mv %{buildroot}%{_mandir}/man1/dnsquery.1 \
    %{buildroot}%{_mandir}/man1/dnsquery8.1
mv %{buildroot}%{_mandir}/man1/host.1 \
    %{buildroot}%{_mandir}/man1/host8.1
mv %{buildroot}%{_mandir}/man5/irs.conf.5 \
    %{buildroot}%{_mandir}/man5/irs8.conf.5
mv %{buildroot}%{_mandir}/man5/resolver.5 \
    %{buildroot}%{_mandir}/man5/resolver8.5
mv %{buildroot}%{_mandir}/man8/nslookup.8 \
    %{buildroot}%{_mandir}/man8/nslookup8.8
mv %{buildroot}%{_mandir}/man8/nsupdate.8 \
    %{buildroot}%{_mandir}/man8/nsupdate8.8
#
mv %{buildroot}%{_libdir}/nslookup.help \
    %{buildroot}%{_libdir}/nslookup8.help

##################################################################
# obeying new rpm policy, using the "rm" workaround
#
# these conflicts with glibc-devel
rm -f %{buildroot}%{_mandir}/man5/resolv.conf.5*
rm -f %{buildroot}%{_mandir}/man3/getaddrinfo.3*
rm -f %{buildroot}%{_mandir}/man3/getnetent.3*
rm -f %{buildroot}%{_mandir}/man3/resolver.3*

# these conflicts with man-pages
rm -f %{buildroot}%{_mandir}/man3/resolver.3*
rm -f %{buildroot}%{_mandir}/man3/getaddrinfo.3*
rm -f %{buildroot}%{_mandir}/man3/gethostbyname.3*
rm -f %{buildroot}%{_mandir}/man3/getipnodebyname.3*
rm -f %{buildroot}%{_mandir}/man3/getnameinfo.3*
rm -f %{buildroot}%{_mandir}/man3/getnetent.3*
rm -f %{buildroot}%{_mandir}/man7/mailaddr.7*
##################################################################

# nuke redundant stuff here
rm -f %{buildroot}%{_sbindir}/named-bootconf
rm -f %{buildroot}%{_mandir}/man8/named-bootconf.8
rm -f %{buildroot}%{_mandir}/man7/hostname.7

rm -f %{buildroot}%{_mandir}/man3/hesiod.3
rm -f %{buildroot}%{_mandir}/man3/inet_cidr.3
rm -f %{buildroot}%{_mandir}/man3/tsig.3
rm -f %{buildroot}%{_libdir}/*.a
rm -rf %{buildroot}%{_includedir}

%pre
%_pre_useradd named8 /var/named8 /bin/false

%post
%_post_service named8

%preun
%_preun_service named8

%postun
%_postun_userdel named8

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc src/CHANGES src/DNSSEC src/README src/SUPPORT src/TODO src/Version
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/named8.conf
%attr(0755,root,root) %config(noreplace) %{_initrddir}/named8
%attr(0755,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/named8
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/named8
%{_sbindir}/bind8-chroot.sh
%{_sbindir}/dnskeygen8
%{_sbindir}/irpd8
%{_sbindir}/named8
%{_sbindir}/named-xfer8
%{_sbindir}/ndc8
%{_mandir}/man1/dnskeygen8.1*
%{_mandir}/man5/named8.conf.5*
%{_mandir}/man8/named8.8*
%{_mandir}/man8/ndc8.8*
%{_mandir}/man8/named-xfer8.8*
%attr(-,named8,named8) %dir /var/named8
%attr(-,root,root) %config /var/named8/named.cache
%attr(-,root,root) %config /var/named8/0.0.127.in-addr.arpa.db
%attr(-,root,root) %config /var/named8/localhost.db
%attr(-,named8,named8) %dir /var/run/named8
%attr(-,named8,named8) %dir /var/log/named8
     
%files utils
%defattr(-,root,root)
%{_bindir}/addr8
%{_bindir}/dig8
%{_bindir}/dnsquery8
%{_bindir}/host8
%{_bindir}/mkservdb8
%{_bindir}/nslookup8
%{_bindir}/nsupdate8
%{_libdir}/nslookup8.help
%{_mandir}/man1/dig8.1*
%{_mandir}/man1/dnsquery8.1*
%{_mandir}/man1/host8.1*
%{_mandir}/man5/irs8.conf.5*
%{_mandir}/man5/resolver8.5*
%{_mandir}/man8/nslookup8.8*
%{_mandir}/man8/nsupdate8.8*

%changelog
* Wed Jan 26 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 8.4.6-1mdk
- 8.4.6

* Wed Nov 10 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 8.4.5-1mdk
- rename the whole shebang to bind8 and remove the chroot hacks

* Thu Sep 23 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 8.4.5-1mdk
- 8.4.5

* Sat Sep 04 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 8.4.5-0.RC7.1mdk
- 8.4.5-RC7

* Tue Aug 17 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 8.4.5-0.RC6.1mdk
- 8.4.5-RC6

* Fri Jun 18 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 8.4.5-0.RC4.1mdk
- 8.4.5-RC4
- move the jail to /var/lib/named-chroot
- updated S6

* Sat May 08 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 8.4.4-1mdk
- 8.4.4

* Thu Nov 27 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.3-1mdk
- 8.4.3
- new S2
- misc spec file fixes
- drop P14, it's unmaintained for 8.x but provided since bind-9.2.3-3mdk

* Fri Jul 25 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.1-3mdk
- fixed a glitch in the sysv script pointed out by Maros Michalik

* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.1-2mdk
- rebuild

* Mon Jun 09 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.1-1mdk
- 8.4.1

* Mon Jun 02 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.0-1mdk
- 8.4.0

* Fri May 30 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.0-0.1mdk
- duh!

* Wed May 28 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.0-0.RC2.1mdk
- 8.4.0-RC2

* Sat May 03 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.0-0.RC1.2mdk
- gotta fix release number, he he he...

* Sat May 03 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.0-0.RC1.1mdk
- 8.4.0-RC1

* Tue Apr 29 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.0-0.T2B.1mdk
- 8.4.0-T2B

* Sun Apr 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.4.0-0.T1B.1mdk
- 8.4.0-T1B
- rediff P2

* Thu Jan 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.4-2mdk
- build release

* Mon Nov 18 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.4-1mdk
- new version (includes fixes for CAN-2002-1219, CAN-2002-1220 and 
  CAN-2002-1221)
- obeying new rpm policy, using the "rm" workaround

* Wed Nov 13 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.3-3mdk
- security fix for multiple flaws in the code (P10) possible addresses;
  CAN-2002-1219, CAN-2002-1220 and CAN-2002-1221, this is something
  for mandrakesecurity to sort out on paid workingtime ;)
- updated S6 to _show_ a fake version to fool the script kiddies even
  more, root should change this later to maybe 9.2.2?
  updated root cache file from internic
- added debug to S3 (service named-chroot debug) to enable the debug 
  channel

* Sun Aug  4 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.3-2mdk
- rebuilt with gcc-3.2
- added BuildRequires: glibc-static-devel for ML9.x
- added Conflicts: glibc-devel for bind-chroot-devel

* Sat Jun 29 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.3-1mdk
- new version
- ship gzipped source and its GnuPG signature
- P13 is included upstream but with a twist. removed P13 from
  the package

* Tue Jun 25 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.2-2mdk
- fixed a glitch in the initscript

* Tue Jun 25 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.2-1mdk
- new version
- de-activate P14 for now
- fixed offending -ll stuff (thanks to Thierry Vignaud and J.A. 
  Magallon for clarifying that.)

* Mon May 20 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.1-6mdk
- rebuilt with gcc3.1

* Fri May  6 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.1-5mdk
- renamed subpackages to avoid name conflicts, thanks Warly.

* Sat Apr 27 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.1-4mdk
- remove legacy softlink to /etc/named.conf for caching-nameserver compliance,
  thanks Salane King for reporting this

* Sat Apr 27 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.1-3mdk
- fix obsoletes and provides, pointed out by Alexander Skwar, thanks!
- also change sysv script name to named-chroot (yes, you probably can run both
  bind-chroot and bind-9.x at the same time, but that's another story...)

* Sun Apr 21 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.1-2mdk
- re-activated non-ascii domain names support (P14). Soon we'll probably be able
  to use domain names like www.gllivare.se, so we'll better provide :)
- ripped the man pages to reduce overall size
- misc spec file fixes (Mr. rpmlint)
- initial cooker contrib

* Sun Feb 3 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.3.1-1mdk
- update to 8.3.1
- deactivate some patches
- adjusted P6 & P7

* Tue Oct 2 2001 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.2.5-1mdk
- update to 8.2.5
 
* Sun Feb 3 2001 Oden Eriksson <oden.eriksson@kvikkjokk.net> 8.2.3-1mdk
- update to 8.2.3
- enhanced the jail package
- inactivate obsolete? patches for now.
- added non-ascii domain names support. (patch14)
- removed logrotate stuff, bind handles that itself.
- removed the "contrib" source. (it's pretty old and useless)
- mandrakified the package...

* Sat Dec  9 2000 Oden Eriksson <oden.eriksson@kvikkjokk.net>
- update to 8.2.2-P7
- added the chaos1 patch.
- added rh patches.
- made the jaildir as %{jail}

* Fri Jan  7 2000 Jan "Yenya" Kasprzak <kas@fi.muni.cz>
- modified the official RedHat package to the chrooted environment
  (using pieces of John A. Martin <jam@jamux.com>'s bind-chroot-8.1.2
  source RPM).
- update to 8.2.2-P5

* Wed Nov 10 1999 Bill Nottingham <notting@redhat.com>
- update to 8.2.2-P3

* Tue Oct 12 1999 Cristian Gafton <gafton@redhat.com>
- add patch to stop a cache only server from complaining about lame servers
  on every request.

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- use real stop and start in named.init for restart, not ndc restart, it has
  problems when named has changed during a package update... (# 4890)

* Fri Sep 10 1999 Bill Nottingham <notting@redhat.com>
- chkconfig --del in %preun, not %postun

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Mon Jul 26 1999 Bill Nottingham <notting@redhat.com>
- fix installed chkconfig links to match init file

* Sat Jul  3 1999 Jeff Johnson <jbj@redhat.com>
- conflict with new (in man-1.24) man pages (#3876,#3877).

* Tue Jun 29 1999 Bill Nottingham <notting@redhat.com>
- fix named.logrotate (wrong %SOURCE)

* Fri Jun 25 1999 Jeff Johnson <jbj@redhat.com>
- update to 8.2.1.
- add named.logrotate (#3571).
- hack around egcs-1.1.2 -m486 bug (#3413, #3485).
- vet file list.

* Fri Jun 18 1999 Bill Nottingham <notting@redhat.com>
- don't run by default

* Sun May 30 1999 Jeff Johnson <jbj@redhat.com>
- nslookup fixes (#2463).
- missing files (#3152).

* Sat May  1 1999 Stepan Kasal <kasal@math.cas.cz>
- nslookup patched:
  to count numRecords properly
  to fix subsequent calls to ls -d
  to parse "view" and "finger" commands properly
  the view hack updated for bind-8 (using sed)

* Wed Mar 31 1999 Bill Nottingham <notting@redhat.com>
- add ISC patch
- add quick hack to make host not crash
- add more docs

* Fri Mar 26 1999 Cristian Gafton <gafton@redhat.com>
- add probing information in the init file to keep linuxconf happy
- dont strip libbind

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Wed Mar 17 1999 Preston Brown <pbrown@redhat.com>
- removed 'done' output at named shutdown.

* Tue Mar 16 1999 Cristian Gafton <gafton@redhat.com>
- version 8.2

* Wed Dec 30 1998 Cristian Gafton <gafton@redhat.com>
- patch to use the __FDS_BITS macro
- build for glibc 2.1

* Wed Sep 23 1998 Jeff Johnson <jbj@redhat.com>
- change named.restart to %{_sbindir}/ndc restart

* Sat Sep 19 1998 Jeff Johnson <jbj@redhat.com>
- install man pages correctly.
- change K10named to K45named.

* Wed Aug 12 1998 Jeff Johnson <jbj@redhat.com>
- don't start if %{_sysconfdir}/named.conf doesn't exist.

* Sat Aug  8 1998 Jeff Johnson <jbj@redhat.com>
- autmagically create %{_sysconfdir}/named.conf from %{_sysconfdir}/named.boot in %post
- remove echo in %post

* Wed Jun 10 1998 Jeff Johnson <jbj@redhat.com>
- merge in 5.1 mods

* Sun Apr 12 1998 Manuel J. Galan <manolow@step.es>
- Several essential modifications to build and install correctly.
- Modified 'ndc' to avoid deprecated use of '-'

* Mon Dec 22 1997 Scott Lampert <fortunato@heavymetal.org>
- Used buildroot
- patched bin/named/ns_udp.c to use <libelf/nlist.h> for include
  on Redhat 5.0 instead of <nlist.h>

